git-filter-branch.shon commit Merge branch 'maint' (e7e5548)
   1#!/bin/sh
   2#
   3# Rewrite revision history
   4# Copyright (c) Petr Baudis, 2006
   5# Minimal changes to "port" it to core-git (c) Johannes Schindelin, 2007
   6#
   7# Lets you rewrite the revision history of the current branch, creating
   8# a new branch. You can specify a number of filters to modify the commits,
   9# files and trees.
  10
  11# The following functions will also be available in the commit filter:
  12
  13functions=$(cat << \EOF
  14warn () {
  15        echo "$*" >&2
  16}
  17
  18map()
  19{
  20        # if it was not rewritten, take the original
  21        if test -r "$workdir/../map/$1"
  22        then
  23                cat "$workdir/../map/$1"
  24        else
  25                echo "$1"
  26        fi
  27}
  28
  29# if you run 'skip_commit "$@"' in a commit filter, it will print
  30# the (mapped) parents, effectively skipping the commit.
  31
  32skip_commit()
  33{
  34        shift;
  35        while [ -n "$1" ];
  36        do
  37                shift;
  38                map "$1";
  39                shift;
  40        done;
  41}
  42
  43# if you run 'git_commit_non_empty_tree "$@"' in a commit filter,
  44# it will skip commits that leave the tree untouched, commit the other.
  45git_commit_non_empty_tree()
  46{
  47        if test $# = 3 && test "$1" = $(git rev-parse "$3^{tree}"); then
  48                map "$3"
  49        else
  50                git commit-tree "$@"
  51        fi
  52}
  53# override die(): this version puts in an extra line break, so that
  54# the progress is still visible
  55
  56die()
  57{
  58        echo >&2
  59        echo "$*" >&2
  60        exit 1
  61}
  62EOF
  63)
  64
  65eval "$functions"
  66
  67# When piped a commit, output a script to set the ident of either
  68# "author" or "committer
  69
  70set_ident () {
  71        lid="$(echo "$1" | tr "[A-Z]" "[a-z]")"
  72        uid="$(echo "$1" | tr "[a-z]" "[A-Z]")"
  73        pick_id_script='
  74                /^'$lid' /{
  75                        s/'\''/'\''\\'\'\''/g
  76                        h
  77                        s/^'$lid' \([^<]*\) <[^>]*> .*$/\1/
  78                        s/'\''/'\''\'\'\''/g
  79                        s/.*/GIT_'$uid'_NAME='\''&'\''; export GIT_'$uid'_NAME/p
  80
  81                        g
  82                        s/^'$lid' [^<]* <\([^>]*\)> .*$/\1/
  83                        s/'\''/'\''\'\'\''/g
  84                        s/.*/GIT_'$uid'_EMAIL='\''&'\''; export GIT_'$uid'_EMAIL/p
  85
  86                        g
  87                        s/^'$lid' [^<]* <[^>]*> \(.*\)$/\1/
  88                        s/'\''/'\''\'\'\''/g
  89                        s/.*/GIT_'$uid'_DATE='\''&'\''; export GIT_'$uid'_DATE/p
  90
  91                        q
  92                }
  93        '
  94
  95        LANG=C LC_ALL=C sed -ne "$pick_id_script"
  96        # Ensure non-empty id name.
  97        echo "case \"\$GIT_${uid}_NAME\" in \"\") GIT_${uid}_NAME=\"\${GIT_${uid}_EMAIL%%@*}\" && export GIT_${uid}_NAME;; esac"
  98}
  99
 100USAGE="[--env-filter <command>] [--tree-filter <command>]
 101            [--index-filter <command>] [--parent-filter <command>]
 102            [--msg-filter <command>] [--commit-filter <command>]
 103            [--tag-name-filter <command>] [--subdirectory-filter <directory>]
 104            [--original <namespace>] [-d <directory>] [-f | --force]
 105            [<rev-list options>...]"
 106
 107OPTIONS_SPEC=
 108. git-sh-setup
 109
 110if [ "$(is_bare_repository)" = false ]; then
 111        git diff-files --ignore-submodules --quiet &&
 112        git diff-index --cached --quiet HEAD -- ||
 113        die "Cannot rewrite branch(es) with a dirty working directory."
 114fi
 115
 116tempdir=.git-rewrite
 117filter_env=
 118filter_tree=
 119filter_index=
 120filter_parent=
 121filter_msg=cat
 122filter_commit=
 123filter_tag_name=
 124filter_subdir=
 125orig_namespace=refs/original/
 126force=
 127prune_empty=
 128while :
 129do
 130        case "$1" in
 131        --)
 132                shift
 133                break
 134                ;;
 135        --force|-f)
 136                shift
 137                force=t
 138                continue
 139                ;;
 140        --prune-empty)
 141                shift
 142                prune_empty=t
 143                continue
 144                ;;
 145        -*)
 146                ;;
 147        *)
 148                break;
 149        esac
 150
 151        # all switches take one argument
 152        ARG="$1"
 153        case "$#" in 1) usage ;; esac
 154        shift
 155        OPTARG="$1"
 156        shift
 157
 158        case "$ARG" in
 159        -d)
 160                tempdir="$OPTARG"
 161                ;;
 162        --env-filter)
 163                filter_env="$OPTARG"
 164                ;;
 165        --tree-filter)
 166                filter_tree="$OPTARG"
 167                ;;
 168        --index-filter)
 169                filter_index="$OPTARG"
 170                ;;
 171        --parent-filter)
 172                filter_parent="$OPTARG"
 173                ;;
 174        --msg-filter)
 175                filter_msg="$OPTARG"
 176                ;;
 177        --commit-filter)
 178                filter_commit="$functions; $OPTARG"
 179                ;;
 180        --tag-name-filter)
 181                filter_tag_name="$OPTARG"
 182                ;;
 183        --subdirectory-filter)
 184                filter_subdir="$OPTARG"
 185                ;;
 186        --original)
 187                orig_namespace=$(expr "$OPTARG/" : '\(.*[^/]\)/*$')/
 188                ;;
 189        *)
 190                usage
 191                ;;
 192        esac
 193done
 194
 195case "$prune_empty,$filter_commit" in
 196,)
 197        filter_commit='git commit-tree "$@"';;
 198t,)
 199        filter_commit="$functions;"' git_commit_non_empty_tree "$@"';;
 200,*)
 201        ;;
 202*)
 203        die "Cannot set --prune-empty and --filter-commit at the same time"
 204esac
 205
 206case "$force" in
 207t)
 208        rm -rf "$tempdir"
 209;;
 210'')
 211        test -d "$tempdir" &&
 212                die "$tempdir already exists, please remove it"
 213esac
 214mkdir -p "$tempdir/t" &&
 215tempdir="$(cd "$tempdir"; pwd)" &&
 216cd "$tempdir/t" &&
 217workdir="$(pwd)" ||
 218die ""
 219
 220# Remove tempdir on exit
 221trap 'cd ../..; rm -rf "$tempdir"' 0
 222
 223ORIG_GIT_DIR="$GIT_DIR"
 224ORIG_GIT_WORK_TREE="$GIT_WORK_TREE"
 225ORIG_GIT_INDEX_FILE="$GIT_INDEX_FILE"
 226GIT_WORK_TREE=.
 227export GIT_DIR GIT_WORK_TREE
 228
 229# Make sure refs/original is empty
 230git for-each-ref > "$tempdir"/backup-refs || exit
 231while read sha1 type name
 232do
 233        case "$force,$name" in
 234        ,$orig_namespace*)
 235                die "Cannot create a new backup.
 236A previous backup already exists in $orig_namespace
 237Force overwriting the backup with -f"
 238        ;;
 239        t,$orig_namespace*)
 240                git update-ref -d "$name" $sha1
 241        ;;
 242        esac
 243done < "$tempdir"/backup-refs
 244
 245# The refs should be updated if their heads were rewritten
 246git rev-parse --no-flags --revs-only --symbolic-full-name \
 247        --default HEAD "$@" > "$tempdir"/raw-heads || exit
 248sed -e '/^^/d' "$tempdir"/raw-heads >"$tempdir"/heads
 249
 250test -s "$tempdir"/heads ||
 251        die "Which ref do you want to rewrite?"
 252
 253GIT_INDEX_FILE="$(pwd)/../index"
 254export GIT_INDEX_FILE
 255git read-tree || die "Could not seed the index"
 256
 257# map old->new commit ids for rewriting parents
 258mkdir ../map || die "Could not create map/ directory"
 259
 260case "$filter_subdir" in
 261"")
 262        git rev-list --reverse --topo-order --default HEAD \
 263                --parents --simplify-merges "$@"
 264        ;;
 265*)
 266        git rev-list --reverse --topo-order --default HEAD \
 267                --parents --simplify-merges "$@" -- "$filter_subdir"
 268esac > ../revs || die "Could not get the commits"
 269commits=$(wc -l <../revs | tr -d " ")
 270
 271test $commits -eq 0 && die "Found nothing to rewrite"
 272
 273# Rewrite the commits
 274
 275git_filter_branch__commit_count=0
 276while read commit parents; do
 277        git_filter_branch__commit_count=$(($git_filter_branch__commit_count+1))
 278        printf "\rRewrite $commit ($git_filter_branch__commit_count/$commits)"
 279
 280        case "$filter_subdir" in
 281        "")
 282                git read-tree -i -m $commit
 283                ;;
 284        *)
 285                # The commit may not have the subdirectory at all
 286                err=$(git read-tree -i -m $commit:"$filter_subdir" 2>&1) || {
 287                        if ! git rev-parse -q --verify $commit:"$filter_subdir"
 288                        then
 289                                rm -f "$GIT_INDEX_FILE"
 290                        else
 291                                echo >&2 "$err"
 292                                false
 293                        fi
 294                }
 295        esac || die "Could not initialize the index"
 296
 297        GIT_COMMIT=$commit
 298        export GIT_COMMIT
 299        git cat-file commit "$commit" >../commit ||
 300                die "Cannot read commit $commit"
 301
 302        eval "$(set_ident AUTHOR <../commit)" ||
 303                die "setting author failed for commit $commit"
 304        eval "$(set_ident COMMITTER <../commit)" ||
 305                die "setting committer failed for commit $commit"
 306        eval "$filter_env" < /dev/null ||
 307                die "env filter failed: $filter_env"
 308
 309        if [ "$filter_tree" ]; then
 310                git checkout-index -f -u -a ||
 311                        die "Could not checkout the index"
 312                # files that $commit removed are now still in the working tree;
 313                # remove them, else they would be added again
 314                git clean -d -q -f -x
 315                eval "$filter_tree" < /dev/null ||
 316                        die "tree filter failed: $filter_tree"
 317
 318                (
 319                        git diff-index -r --name-only $commit &&
 320                        git ls-files --others
 321                ) > "$tempdir"/tree-state || exit
 322                git update-index --add --replace --remove --stdin \
 323                        < "$tempdir"/tree-state || exit
 324        fi
 325
 326        eval "$filter_index" < /dev/null ||
 327                die "index filter failed: $filter_index"
 328
 329        parentstr=
 330        for parent in $parents; do
 331                for reparent in $(map "$parent"); do
 332                        parentstr="$parentstr -p $reparent"
 333                done
 334        done
 335        if [ "$filter_parent" ]; then
 336                parentstr="$(echo "$parentstr" | eval "$filter_parent")" ||
 337                                die "parent filter failed: $filter_parent"
 338        fi
 339
 340        sed -e '1,/^$/d' <../commit | \
 341                eval "$filter_msg" > ../message ||
 342                        die "msg filter failed: $filter_msg"
 343        @SHELL_PATH@ -c "$filter_commit" "git commit-tree" \
 344                $(git write-tree) $parentstr < ../message > ../map/$commit ||
 345                        die "could not write rewritten commit"
 346done <../revs
 347
 348# In case of a subdirectory filter, it is possible that a specified head
 349# is not in the set of rewritten commits, because it was pruned by the
 350# revision walker.  Fix it by mapping these heads to the unique nearest
 351# ancestor that survived the pruning.
 352
 353if test "$filter_subdir"
 354then
 355        while read ref
 356        do
 357                sha1=$(git rev-parse "$ref"^0)
 358                test -f "$workdir"/../map/$sha1 && continue
 359                ancestor=$(git rev-list --simplify-merges -1 \
 360                                $ref -- "$filter_subdir")
 361                test "$ancestor" && echo $(map $ancestor) >> "$workdir"/../map/$sha1
 362        done < "$tempdir"/heads
 363fi
 364
 365# Finally update the refs
 366
 367_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 368_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
 369echo
 370while read ref
 371do
 372        # avoid rewriting a ref twice
 373        test -f "$orig_namespace$ref" && continue
 374
 375        sha1=$(git rev-parse "$ref"^0)
 376        rewritten=$(map $sha1)
 377
 378        test $sha1 = "$rewritten" &&
 379                warn "WARNING: Ref '$ref' is unchanged" &&
 380                continue
 381
 382        case "$rewritten" in
 383        '')
 384                echo "Ref '$ref' was deleted"
 385                git update-ref -m "filter-branch: delete" -d "$ref" $sha1 ||
 386                        die "Could not delete $ref"
 387        ;;
 388        $_x40)
 389                echo "Ref '$ref' was rewritten"
 390                if ! git update-ref -m "filter-branch: rewrite" \
 391                                        "$ref" $rewritten $sha1 2>/dev/null; then
 392                        if test $(git cat-file -t "$ref") = tag; then
 393                                if test -z "$filter_tag_name"; then
 394                                        warn "WARNING: You said to rewrite tagged commits, but not the corresponding tag."
 395                                        warn "WARNING: Perhaps use '--tag-name-filter cat' to rewrite the tag."
 396                                fi
 397                        else
 398                                die "Could not rewrite $ref"
 399                        fi
 400                fi
 401        ;;
 402        *)
 403                # NEEDSWORK: possibly add -Werror, making this an error
 404                warn "WARNING: '$ref' was rewritten into multiple commits:"
 405                warn "$rewritten"
 406                warn "WARNING: Ref '$ref' points to the first one now."
 407                rewritten=$(echo "$rewritten" | head -n 1)
 408                git update-ref -m "filter-branch: rewrite to first" \
 409                                "$ref" $rewritten $sha1 ||
 410                        die "Could not rewrite $ref"
 411        ;;
 412        esac
 413        git update-ref -m "filter-branch: backup" "$orig_namespace$ref" $sha1 ||
 414                 exit
 415done < "$tempdir"/heads
 416
 417# TODO: This should possibly go, with the semantics that all positive given
 418#       refs are updated, and their original heads stored in refs/original/
 419# Filter tags
 420
 421if [ "$filter_tag_name" ]; then
 422        git for-each-ref --format='%(objectname) %(objecttype) %(refname)' refs/tags |
 423        while read sha1 type ref; do
 424                ref="${ref#refs/tags/}"
 425                # XXX: Rewrite tagged trees as well?
 426                if [ "$type" != "commit" -a "$type" != "tag" ]; then
 427                        continue;
 428                fi
 429
 430                if [ "$type" = "tag" ]; then
 431                        # Dereference to a commit
 432                        sha1t="$sha1"
 433                        sha1="$(git rev-parse -q "$sha1"^{commit})" || continue
 434                fi
 435
 436                [ -f "../map/$sha1" ] || continue
 437                new_sha1="$(cat "../map/$sha1")"
 438                GIT_COMMIT="$sha1"
 439                export GIT_COMMIT
 440                new_ref="$(echo "$ref" | eval "$filter_tag_name")" ||
 441                        die "tag name filter failed: $filter_tag_name"
 442
 443                echo "$ref -> $new_ref ($sha1 -> $new_sha1)"
 444
 445                if [ "$type" = "tag" ]; then
 446                        new_sha1=$( ( printf 'object %s\ntype commit\ntag %s\n' \
 447                                                "$new_sha1" "$new_ref"
 448                                git cat-file tag "$ref" |
 449                                sed -n \
 450                                    -e "1,/^$/{
 451                                          /^object /d
 452                                          /^type /d
 453                                          /^tag /d
 454                                        }" \
 455                                    -e '/^-----BEGIN PGP SIGNATURE-----/q' \
 456                                    -e 'p' ) |
 457                                git mktag) ||
 458                                die "Could not create new tag object for $ref"
 459                        if git cat-file tag "$ref" | \
 460                           grep '^-----BEGIN PGP SIGNATURE-----' >/dev/null 2>&1
 461                        then
 462                                warn "gpg signature stripped from tag object $sha1t"
 463                        fi
 464                fi
 465
 466                git update-ref "refs/tags/$new_ref" "$new_sha1" ||
 467                        die "Could not write tag $new_ref"
 468        done
 469fi
 470
 471cd ../..
 472rm -rf "$tempdir"
 473
 474trap - 0
 475
 476unset GIT_DIR GIT_WORK_TREE GIT_INDEX_FILE
 477test -z "$ORIG_GIT_DIR" || {
 478        GIT_DIR="$ORIG_GIT_DIR" && export GIT_DIR
 479}
 480test -z "$ORIG_GIT_WORK_TREE" || {
 481        GIT_WORK_TREE="$ORIG_GIT_WORK_TREE" &&
 482        export GIT_WORK_TREE
 483}
 484test -z "$ORIG_GIT_INDEX_FILE" || {
 485        GIT_INDEX_FILE="$ORIG_GIT_INDEX_FILE" &&
 486        export GIT_INDEX_FILE
 487}
 488
 489if [ "$(is_bare_repository)" = false ]; then
 490        git read-tree -u -m HEAD || exit
 491fi
 492
 493exit 0